<?php namespace Site21\ExtendSitemap;

use Backend;
use System\Classes\PluginBase;
use Event;
use Site21\ExtendSitemap\Models\ExtendSitemap as ExtendSitemapModel;

/**
 * ExtendSitemap Plugin Information File
 */
class Plugin extends PluginBase
{
    /**
     * Returns information about this plugin.
     *
     * @return array
     */
    public function pluginDetails()
    {
        return [
            'name'        => 'ExtendSitemap',
            'description' => 'No description provided yet...',
            'author'      => 'Site21',
            'icon'        => 'icon-leaf'
        ];
    }

    /**
     * Register method, called when the plugin is first registered.
     *
     * @return void
     */
    public function register()
    {

    }

    /**
     * Boot method, called right before the request route.
     *
     * @return array
     */
    public function boot()
    {
		$this->bootMenuItem();
    }

    /**
     * Registers any front-end components implemented in this plugin.
     *
     * @return array
     */
    public function registerComponents()
    {
        return []; // Remove this line to activate

        return [
            'Site21\ExtendSitemap\Components\MyComponent' => 'myComponent',
        ];
    }

    /**
     * Registers any back-end permissions used by this plugin.
     *
     * @return array
     */
    public function registerPermissions()
    {
        return []; // Remove this line to activate

        return [
            'site21.extendsitemap.some_permission' => [
                'tab' => 'ExtendSitemap',
                'label' => 'Some permission'
            ],
        ];
    }

    /**
     * Registers back-end navigation items for this plugin.
     *
     * @return array
     */
    public function registerNavigation()
    {
        return []; // Remove this line to activate

        return [
            'extendsitemap' => [
                'label'       => 'ExtendSitemap',
                'url'         => Backend::url('site21/extendsitemap/mycontroller'),
                'icon'        => 'icon-leaf',
                'permissions' => ['site21.extendsitemap.*'],
                'order'       => 500,
            ],
        ];
    }
    
	private function bootMenuItem() {
		Event::listen('pages.menuitem.listTypes', function () {
		    return [
		        'all-products' => 'Все товары',
		    ];
		});
		
		Event::listen('pages.menuitem.getTypeInfo', function ($type) {
		    if ($type == 'all-products') {
		        return [
		            'dynamicItems' => true,
		        ];
		    }
		});
		
		Event::listen('pages.menuitem.resolveItem', function ($type, $item, $url, $theme) {
		    if ($type == 'all-products') {
		        return ExtendSitemapModel::resolveMenuItem($item, $url, $theme);
		    }
		});
	}
}
