<?php namespace Site21\ExtendSitemap\Models;

use Model;
use Cms\Classes\Page;
use Lovata\Shopaholic\Models\Category;
use Lovata\Shopaholic\Models\Product;

/**
 * ExtendSitemap Model
 */
class ExtendSitemap extends Model
{
    use \October\Rain\Database\Traits\Validation;

    /**
     * @var string The database table used by the model.
     */
    public $table = 'site21_extendsitemap_extend_sitemaps';
    

    /**
     * @var array Guarded fields
     */
    protected $guarded = ['*'];

    /**
     * @var array Fillable fields
     */
    protected $fillable = [];

    /**
     * @var array Validation rules for attributes
     */
    public $rules = [];

    /**
     * @var array Attributes to be cast to native types
     */
    protected $casts = [];

    /**
     * @var array Attributes to be cast to JSON
     */
    protected $jsonable = [];

    /**
     * @var array Attributes to be appended to the API representation of the model (ex. toArray())
     */
    protected $appends = [];

    /**
     * @var array Attributes to be removed from the API representation of the model (ex. toArray())
     */
    protected $hidden = [];

    /**
     * @var array Attributes to be cast to Argon (Carbon) instances
     */
    protected $dates = [
        'created_at',
        'updated_at'
    ];

    /**
     * @var array Relations
     */
    public $hasOne = [];
    public $hasMany = [];
    public $belongsTo = [];
    public $belongsToMany = [];
    public $morphTo = [];
    public $morphOne = [];
    public $morphMany = [];
    public $attachOne = [];
    public $attachMany = [];
    

	
	public static function resolveMenuItem($item, $url, $theme) {
	    $pageName = 'catalog';
	    $cmsPage = Page::loadCached($theme, $pageName);
	    $items   = Product
	        ::orderBy('id', 'ASC')
	        ->where('active', 1)
	        ->get()
	        ->map(function ($item) use ($cmsPage, $url, $pageName) {
	            $pageUrl = $cmsPage->url($pageName, [
	            	'slug' => $item->slug,
	            	'category' => Category::where('id', $item->category_id)->value('slug')
	            ]);
	
	            return [
	                'title'    => $item->name,
	                'url'      => $pageUrl,
	                'mtime'    => $item->updated_at,
	                'isActive' => $pageUrl === $url,
	            ];
	        })
	        ->toArray();
	
	    return [
	        'items' => $items,
	    ];
	}

	
}
